Loading...
Searching...
No Matches
Opm::PAvgCalculator< Scalar >::Accumulator::Impl< Scalar > Class Template Reference

Implementation class for calculator's accumulator. More...

## Public Member Functions

void | addCentre (const Scalar weight, const Scalar press)
| Add contribution from centre/connecting cell.
void | addRectangular (const Scalar weight, const Scalar press)
| Add contribution from direct, rectangular, level 1 neighbouring cell.
void | addDiagonal (const Scalar weight, const Scalar press)
| Add contribution from diagonal, level 2 neighbouring cell.
void | add (const Scalar weight, const Impl &other)
| Add contribution from other accumulator.
void | prepareAccumulation ()
| Zero out/clear WBP result buffer.
void | prepareContribution ()
| Zero out/clear WBP term buffer.
void | commitContribution (const Scalar innerWeight)
| Accumulate current source term into result buffer whilst applying any user-prescribed term weighting.
LocalRunningAverages | getRunningAverages () const
| Get buffer of intermediate, local results.
void | assignRunningAverages (const LocalRunningAverages &a)
| Assign coalesced/global contributions.
Scalar | getAverageValue (const typename PAvgCalculatorResult< Scalar >::WBPMode type) const
| Retrieve block-average pressure value of specific type.

## Detailed Description

template<class Scalar>
template<class Scalar>
class Opm::PAvgCalculator< Scalar >::Accumulator::Impl< Scalar >

Implementation class for calculator's accumulator.

## Member Function Documentation

## add()

template<class Scalar>
template<class Scalar>

void Opm::PAvgCalculator< Scalar >::Accumulator::Impl< Scalar >::add | ( | const Scalar | weight,
|  | const Impl< Scalar > & | other )

inline

Add contribution from other accumulator.

This typically incorporates a set of results from a single reservoir connection into a larger sum across all connections.

Parameters

  [in] | weight | Pressure weighting factor
  [in] | other | Contribution from other accumulation process.

## addCentre()

template<class Scalar>
template<class Scalar>

void Opm::PAvgCalculator< Scalar >::Accumulator::Impl< Scalar >::addCentre | ( | const Scalar | weight,
|  | const Scalar | press )

inline

Add contribution from centre/connecting cell.

Parameters

  [in] | weight | Pressure weighting factor
  [in] | press | Pressure value

## addDiagonal()

template<class Scalar>
template<class Scalar>

void Opm::PAvgCalculator< Scalar >::Accumulator::Impl< Scalar >::addDiagonal | ( | const Scalar | weight,
|  | const Scalar | press )

inline

Add contribution from diagonal, level 2 neighbouring cell.

Parameters

  [in] | weight | Pressure weighting factor
  [in] | press | Pressure value

## addRectangular()

template<class Scalar>
template<class Scalar>

void Opm::PAvgCalculator< Scalar >::Accumulator::Impl< Scalar >::addRectangular | ( | const Scalar | weight,
|  | const Scalar | press )

inline

Add contribution from direct, rectangular, level 1 neighbouring cell.

Parameters

  [in] | weight | Pressure weighting factor
  [in] | press | Pressure value

## assignRunningAverages()

template<class Scalar>
template<class Scalar>

void Opm::PAvgCalculator< Scalar >::Accumulator::Impl< Scalar >::assignRunningAverages | ( | const LocalRunningAverages & | a | ) |

inline

Assign coalesced/global contributions.

Parameters

  [in] | a | Buffer of coalesced global contributions.

## commitContribution()

template<class Scalar>
template<class Scalar>

void Opm::PAvgCalculator< Scalar >::Accumulator::Impl< Scalar >::commitContribution | ( | const Scalar | innerWeight | ) |

inline

Accumulate current source term into result buffer whilst applying any user-prescribed term weighting.

Parameters

  [in] | innerWeight | Weighting factor for inner/connecting cell contributions. Outer cells weighted by 1-innerWeight where applicable. If inner weight factor is negative, no weighting is applied. Typically the F1 weighting factor from the WPAVE keyword.

## getAverageValue()

template<class Scalar>
template<class Scalar>

Scalar Opm::PAvgCalculator< Scalar >::Accumulator::Impl< Scalar >::getAverageValue | ( | const typename PAvgCalculatorResult< Scalar >::WBPMode | type | ) | const

inline

Retrieve block-average pressure value of specific type.

Parameters

  [in] | type | Kind of block-average pressure

Returns
  Value of specified block-average pressure quantity

The documentation for this class was generated from the following file:

- opm/input/eclipse/Schedule/Well/PAvgCalculator.cpp